%define kver 2.4.21
%define krpmver 47.31AX

Summary:       Aarich (Adaptec close source driver)
Name:          kernel-driver-aarich
Version:       6.00.086.I308
Release:       %{kver}_%{krpmver}_2
License:       proprietary
Group:         System Environment/Kernel
URL:           http://www.adaptec.com/
Source:        aarich-pelican_hill_phase2-ich-build86.tgz
Source1:       filter-requires-kernel.sh
Patch0:        aarich-rhlikekernel.patch
Patch1:        aarich-6.00.084.I308-writebuffer.patch
NoSource:      0

BuildPreReq:   kernel-source = %{kver}-%{krpmver}
Prereq:      kernel = %{kver}-%{krpmver}
Conflicts:     kernel-driver-aarich2 = %{version}-%{release}

BuildRoot:     %{_tmppath}/%{name}-%{version}-root
ExclusiveArch: i386 i686 ia32e x86_64

%define __perl_requires %{SOURCE1}

%description
This package contains the Aarich kernel module.
Note that this driver does not licensed by the 
OpenSource(TM) term.

%package -n kernel-BOOT-driver-aarich
Summary: Aarich (Adaptec close source driver) for BOOT kernel
Group: System Environment/Kernel
Prereq: kernel-BOOT = %{kver}-%{krpmver}
Conflicts:     kernel-BOOT-driver-aarich2 = %{version}-%{release}

%description -n kernel-BOOT-driver-aarich
This package contains the Aarich kernel module for BOOT kernel

%package -n kernel-smp-driver-aarich
Summary: Aarich (Adaptec close source driver) for smp kernel
Group: System Environment/Kernel
Prereq: kernel-smp = %{kver}-%{krpmver}
Conflicts:     kernel-smp-driver-aarich2 = %{version}-%{release}

%description -n kernel-smp-driver-aarich
This package contains the Aarich kernel module for smp kernel

%package -n kernel-hugemem-driver-aarich
Summary: Aarich (Adaptec close source driver) for hugemem kernel
Group: System Environment/Kernel
Prereq: kernel-hugemem = %{kver}-%{krpmver}
Conflicts:     kernel-hugemem-driver-aarich2 = %{version}-%{release}

%description -n kernel-hugemem-driver-aarich
This package contains the Aarich kernel module for hugemem kernel

%prep
%setup -q -c aarich
%patch0 -p0
%patch1 -p0

## copy kernel tree for build
/bin/cp -a /usr/src/linux-%{kver}-%{krpmver} .
cd linux-%{kver}-%{krpmver}
## for safe
make clean
ln -s ../../../aarich drivers/scsi/aarich
perl -p -i -e "s/^EXTRAVERSION.*/EXTRAVERSION = -prep/" Makefile
#perl -p -i -e "s/^NAME.*/NAME = Asianux/" Makefile
cd ..

%build
rm -rf $RPM_BUILD_ROOT
cd linux-%{kver}-%{krpmver}

BuildDriver() {
  make -s mrproper
  KernelVer=%{kver}-%{krpmver}$1
  ModuleDir=$RPM_BUILD_ROOT/lib/modules/$KernelVer/kernel/drivers/scsi
  mkdir -p $ModuleDir
  perl -p -i -e "s/^EXTRAVERSION.*/EXTRAVERSION = -%{krpmver}$1/" Makefile
  if [ -n "$1" ]; then
    cp -a configs/kernel-%{kver}-%{_target_cpu}-$1.config .config
  else
    cp -a configs/kernel-%{kver}-%{_target_cpu}.config .config
  fi
  #if [ ! -L include/asm ]; then
  #  ln -sf asm-%{_arch} include/asm
  #fi
  make -s oldconfig_nonint
  make -s oldconfig_nonint
  make -s scripts/mkdep
  make -s dep
  make -s include/linux/version.h
  ## normal module
  ln -sf linux/makefiles/Makefile.k24.aarich drivers/scsi/aarich/Makefile
  make -s SUBDIRS=drivers/scsi/aarich CONFIG_SCSI_AARICH=m modules
  cp -a drivers/scsi/aarich/aarich.o $ModuleDir
  rm -f drivers/scsi/aarich/*o
  ## ph module
#  ln -sf linux/makefiles/Makefile.k24.aarich.ph drivers/scsi/aarich/Makefile
#  make -s SUBDIRS=drivers/scsi/aarich CONFIG_SCSI_AARICH=m modules
#  cp -a drivers/scsi/aarich/aarich2.o $ModuleDir
#  rm -f drivers/scsi/aarich/*o
  make clean
}

# Build driver for each kernels
%ifarch i386
BuildDriver BOOT
%endif
%ifarch i686 x86_64 ia32e
BuildDriver
%endif
%ifarch i686 x86_64
BuildDriver smp
%endif
%ifarch i686
BuildDriver hugemem
%endif

cd ..

%install

%clean
rm -rf ${RPM_BUILD_ROOT}

%ifarch i386
%post -n kernel-BOOT-driver-aarich
[ -x /usr/sbin/module_upgrade ] && /usr/sbin/module_upgrade
[ -x /sbin/new-kernel-pkg ] && /sbin/new-kernel-pkg --mkinitrd --depmod --install %{kver}-%{krpmver}BOOT
exit 0
%endif

%ifarch i686 x86_64 ia32e
%post
[ -x /usr/sbin/module_upgrade ] && /usr/sbin/module_upgrade
[ -x /sbin/new-kernel-pkg ] && /sbin/new-kernel-pkg --mkinitrd --depmod --install %{kver}-%{krpmver}
exit 0
%endif

%ifarch i686 x86_64
%post -n kernel-smp-driver-aarich
[ -x /usr/sbin/module_upgrade ] && /usr/sbin/module_upgrade
[ -x /sbin/new-kernel-pkg ] && /sbin/new-kernel-pkg --mkinitrd --depmod --install %{kver}-%{krpmver}smp
exit 0
%endif

%ifarch i686
%post -n kernel-hugemem-driver-aarich
[ -x /usr/sbin/module_upgrade ] && /usr/sbin/module_upgrade
[ -x /sbin/new-kernel-pkg ] && /sbin/new-kernel-pkg --mkinitrd --depmod --install %{kver}-%{krpmver}hugemem
exit 0
%endif

%ifarch i386
%postun -n kernel-BOOT-driver-aarich
[ -x /usr/sbin/module_upgrade ] && /usr/sbin/module_upgrade
depmod -ae -F /boot/System.map-%{kver}-%{krpmver}BOOT %{kver}-%{krpmver}BOOT
exit 0
%endif

%ifarch i686 x86_64 ia32e
%postun
[ -x /usr/sbin/module_upgrade ] && /usr/sbin/module_upgrade
depmod -ae -F /boot/System.map-%{kver}-%{krpmver} %{kver}-%{krpmver}
exit 0
%endif

%ifarch i686 x86_64
%postun -n kernel-smp-driver-aarich
[ -x /usr/sbin/module_upgrade ] && /usr/sbin/module_upgrade
depmod -ae -F /boot/System.map-%{kver}-%{krpmver}smp %{kver}-%{krpmver}smp
exit 0
%endif

%ifarch i686
%postun -n kernel-hugemem-driver-aarich
[ -x /usr/sbin/module_upgrade ] && /usr/sbin/module_upgrade
depmod -ae -F /boot/System.map-%{kver}-%{krpmver}hugemem %{kver}-%{krpmver}hugemem
exit 0
%endif

%ifarch i386
%files -n kernel-BOOT-driver-aarich
%defattr(0755,root,root)
/lib/modules/%{kver}-%{krpmver}BOOT/kernel/drivers/scsi/*
%endif

%ifarch i686 x86_64 ia32e
%files
%defattr(0755,root,root)
/lib/modules/%{kver}-%{krpmver}/kernel/drivers/scsi/*
%endif

%ifarch i686 x86_64
%files -n kernel-smp-driver-aarich
%defattr(0755,root,root)
/lib/modules/%{kver}-%{krpmver}smp/kernel/drivers/scsi/*
%endif

%ifarch i686
%files -n kernel-hugemem-driver-aarich
%defattr(0755,root,root)
/lib/modules/%{kver}-%{krpmver}hugemem/kernel/drivers/scsi/*
%endif

%changelog
* Mon Jul 14 2008 Hidehiko MATSUMOTO <hmatsumoto@miraclelinux.com>
- Rebuild for kernel-2.4.21-47.31AX

* Thu Mar 06 2008 Robert Lin <robert@miraclelinux.com>
- Rebuild for kernel-2.4.21-47.30AX

* Wed Feb 06 2008 Robert Lin <robert@miraclelinux.com>
- Rebuild for kernel-2.4.21-47.29AX

* Tue Oct 30 2007 Hidehiko Matsumoto <hmatsumoto@miraclelinux.com>
- Rebuild for kernel-2.4.21-47.28AX

* Fri Sep 07 2007 Hidehiko Matsumoto <hmatsumoto@miraclelinux.com>
- Rebuild for kernel-2.4.21-47.27AX

* Wed Jun 27 2007 Hidehiko Matsumoto <hmatsumoto@miraclelinux.com>
- Rebuild for kernel-2.4.21-47.26AX

* Fri May 25 2007 Hidehiko Matsumoto <hmatsumoto@miraclelinux.com>
- Rebuild for kernel-2.4.21-47.25AX

* Wed Apr 18 2007 Hidehiko Matsumoto <hmatsumoto@miraclelinux.com>
- Rebuild for kernel-2.4.21-47.24AX

* Thu Mar 01 2007 Hidehiko Matsumoto <hmatsumoto@miraclelinux.com>
- Rebuild for kernel-2.4.21-47.23AX

* Fri Jul 14 2006 Hiroshi Hara <hhara@miraclelinux.com>
- Rebuild for kernel-2.4.21-40.7AX
- deal with PreReq properly
- separate aarich and aarich2(bugzillaAX#1553)

* Wed Dec 28 2005 Ryoji Kamei <kamei@miraclelinux.com>
- Rebuild for kernel-2.4.21-37.18AX

* Thu Nov 24 2005 Ryoji Kamei <kamei@miraclelinux.com>
- 6.00.086
 
* Thu Nov 10 2005 Ryoji Kamei <kamei@miraclelinux.com>
- Fix %post fail

* Tue Nov  1 2005 Ryoji Kamei <kamei@miraclelinux.com>
- Change default write buffer flag

* Thu Oct 27 2005 Ryoji Kamei <kamei@miraclelinux.com>
- Change package name scheme to kernel-<tag>-driver-<driver_name>
- Asianux 1.0 support

* Tue Oct 25 2005 Ryoji Kamei <kamei@miraclelinux.com>
- Initial packaging

